<template>
  <div class="participants-tab">
    <ObTable
      ref="tender-participants-table"
      :columns="columns"
      :remote-opt="{
        method: getContractors,
        arguments: {
          uuid: tender.uuid
        },
        contentKey: 'participants'
      }"
      :functional-panel="true"
      :table-layout-fixed="true"
      :is-functional-group="false"
      :is-functional-sort="false"
      :is-functional-filter="!selectedUuids.length"
      :with-checkboxes="isDeleteAvailable"
      :show-add-button="isTenderEditable && (!isDeleteAvailable || !selectedUuids.length)"
      :group-by="isShowGroups ? 'group' : null"
      :checked-rows="selectedUuids"
      add-button-text="Добавить участников"
      data-qa="participantsTable"
      class="participant-table"
      @add="onAdd"
      @select="onSelect"
      @row-toggle="onToggle"
      @group-toggle="onToggle"
      @on-load-list="onTableLoaded"
      is-fixed-header
    >
      <template slot="extraFuncButtons">
        <div
          v-if="isDeleteAvailable && selectedUuids.length"
          class="selected-rows-info"
          data-qa="deleteSelectedParticipants"
          @click="onDeleteSelectedParticipants"
        >
          <i class="icon delete" /> Удалить {{ plural(selectedUuids.length, ['участника', 'участников', 'участников']) }}
        </div>

        <ObToggle
          v-if="isParticipantsExists"
          :value="isShowGroups"
          label="Показывать группы контрагентов"
          @change="onShowGroupsChanged"
        />
      </template>

      <template slot="extraFuncToPanel">
        <ObMenuDropdown
          :items="excelDropdownItems"
          icon="excel"
        />
      </template>
    </ObTable>

    <ObModal
      ref="contractor-modal"
      size="extra-large"
      cancelText="Закрыть"
      :isShowControls="true"
      :isReadOnly="true"
      :title="selectedContractor ? selectedContractor.shortTitle : ''"
      data-qa="participantsModal"
    >
      <div
        v-if="selectedContractor"
        class="modal-container"
      >

        <div class="row">
          <div class="col-xs-6">
            <div class="field-row mb2">
              <div>Описание:</div>
              <div>{{ selectedContractor.description }}</div>
            </div>
            <div class="field-row">
              <div>Полное название:</div>
              <div>{{ selectedContractor.shortTitle }}</div>
            </div>
            <div class="field-row">
              <div>ИНН:</div>
              <div>{{ selectedContractor.inn }}</div>
            </div>
            <div class="field-row">
              <div>КПП:</div>
              <div>{{ selectedContractor.kpp }}</div>
            </div>
            <div class="field-row">
              <div>ОГРН:</div>
              <div>{{ selectedContractor.ogrn }}</div>
            </div>
            <div class="field-row">
              <div>ОКПО:</div>
              <div>{{ selectedContractor.okpo }}</div>
            </div>
            <div class="field-row">
              <div>Юридич. адрес:</div>
              <div>{{ selectedContractor.legalAddress }}</div>
            </div>
            <div class="field-row">
              <div>Телефон:</div>
              <div>{{ selectedContractor.phone }}</div>
            </div>
            <div class="field-row">
              <div>Эл. почта:</div>
              <div>{{ selectedContractor.email }}</div>
            </div>
          </div>
          <div class="col-xs-6">
            <div class="participant-statistics">
              <table v-if="selectedContractor.statistics" class="statistics-table">
                <tr>
                  <th>статус</th>
                  <th>RFI</th>
                  <th>RFQ</th>
                  <th>всего</th>
                </tr>
                <tr>
                  <td>Приглашен</td>
                  <td>{{ selectedContractor.statistics.rfi.inviteAmount }}</td>
                  <td>{{ selectedContractor.statistics.rfq.inviteAmount }}</td>
                  <td>{{ selectedContractor.statistics.sum.inviteAmount }}</td>
                </tr>
                <tr>
                  <td>Участвовал</td>
                  <td>{{ selectedContractor.statistics.rfi.participateAmount }}</td>
                  <td>{{ selectedContractor.statistics.rfq.participateAmount }}</td>
                  <td>{{ selectedContractor.statistics.sum.participateAmount }}</td>
                </tr>
                <tr>
                  <td>Вошел в победители</td>
                  <td>{{ selectedContractor.statistics.rfi.winAmount }}</td>
                  <td>{{ selectedContractor.statistics.rfq.winAmount }}</td>
                  <td>{{ selectedContractor.statistics.sum.winAmount }}</td>
                </tr>
                <tr>
                  <td>Проигнорировал</td>
                  <td>{{ selectedContractor.statistics.rfi.ignoreAmount }}</td>
                  <td>{{ selectedContractor.statistics.rfq.ignoreAmount }}</td>
                  <td>{{ selectedContractor.statistics.sum.ignoreAmount }}</td>
                </tr>
                <tr>
                  <td>Отказался</td>
                  <td>{{ selectedContractor.statistics.rfi.rejectAmount }}</td>
                  <td>{{ selectedContractor.statistics.rfq.rejectAmount }}</td>
                  <td>{{ selectedContractor.statistics.sum.rejectAmount }}</td>
                </tr>
              </table>
            </div>
          </div>
        </div>

        <!-- Контактные лица должны быть тут -->

        <div class="field-row mb2">
          <div>Входит в группы:</div>
          <div
            v-if="selectedContractor.groups"
            class="contractors-groups"
          >
            <router-link
              class="contractors-group"
              :to="{ path: `/tenders-contractor-groups/${group.uuid}`}"
              target="_blank"
              v-for="group in selectedContractor.groups"
              :key="group.uuid"
            >
              {{ group.title }}
            </router-link>
          </div>
          <template v-else>
            —
          </template>
        </div>

        <router-link
          target="_blank"
          class="modal-link"
          :to="selectedContractor ? '/tenders-contractors/'+selectedContractor.uuid : ''"
        >Перейти в подробную карточку</router-link>

      </div>
    </ObModal>

    <ObModal
      ref="add-modal"
      size="large"
      :title="`Добавление участников в тендер ${tender.title}`"
    >
      <AddModal
        ref="add-participants"
        @submit="onSubmit"
        @select="onSelect"
      />
    </ObModal>

    <SuccessExport
      ref="successExportModal"
      :data-source="exportResult"
    />
  </div>
</template>

<script>
  import { mapActions } from 'vuex'
  import api from '@/api'

  import ObTable from 'common-components/src/obComponents/obTable'
  import ObModal from 'common-components/src/obComponents/obModal'
  import ObToggle from 'common-components/src/obComponents/obSwitcherCheckbox'

  import AddModal from './modal/addParticipants'
  import ExportExcel from '../mixins/export-excel'
  import ParticipantsMixin from './mixin/participantsMixin'

  export default {
    name: 'tender-tab-buyer-participants',
    mixins: [
      ParticipantsMixin,
      ExportExcel
    ],
    components: {
      ObTable,
      ObToggle,
      ObModal,
      AddModal
    },
    props: {
      tender: {
        type: Object,
        required: true
      }
    },
    computed: {
      columns () {
        return [
          {
            title: 'Группа или контрагент',
            key: 'shortTitle',
            fixed: true
          },
          {
            title: 'Телефон',
            key: 'phone'
          },
          {
            title: 'Эл. почта',
            key: 'email'
          },
          {
            title: 'Входит в группы',
            key: 'groups',
            sortDisable: true,
            html: (data) => {
              return this.stringifyGroupsList(data)
            }
          }
        ]
      },
      isTenderEditable () {
        return this.tender ? this.tender.status === 'DRAFT' || this.tender.status === 'HELD' : false
      },
      isDeleteAvailable () {
        return this.tender ? this.tender.status === 'DRAFT' : false
      }
    },
    data () {
      return {
        api,
        selectedContractor: null,
        selectedUuids: [],
        isParticipantsExists: false
      }
    },
    methods: {
      ...mapActions({
        updateTenderParticipants: 'tenders/updateTenderParticipants'
      }),
      async getContractors ({ page, size, query, sort, uuid }) {
        const response = await api.tenders[`getTenderContractorsByUuid${this.isShowGroups ? 'ByGroups' : ''}`]({
          page, size, query, sort, uuid
        })

        const result = this.parseParticipants(response)

        // To turn on/off groups toggle
        this.isParticipantsExists = Boolean(result.participants.length)

        return result
      },
      loadData (refName) {
        this.$nextTick(() => {
          this.$refs[refName].loadData({ init: true })
        })
      },
      // 👂 Events
      async onSelect (e) {
        this.selectedContractor = e

        const statistics = await api.tenders.getTenderContractorStatistics(e.uuid);
        this.$set(this.selectedContractor, 'statistics', statistics)

        for (let key in this.selectedContractor) {
          if (key !== 'groups') {
            this.selectedContractor[key] = this.selectedContractor[key] || '—'
          }
        }

        this.$refs['contractor-modal'].open()
      },
      onAdd () {
        if (this.$refs['add-participants']) {
          this.$refs['add-participants'].reset()
        }

        this.$refs['add-modal'].open()
        this.loadData('add-participants')
      },
      async onSubmit (uuids) {
        this.$refs['add-modal'].close()

        if (!uuids) {
          return
        }

        await api.tenders.addContractorsToTenderByUuid(this.tender.uuid, { participants: uuids })

        this.loadData('tender-participants-table')
        this.updateTenderParticipants()
      },
      async onDeleteSelectedParticipants () {
        await api.tenders.deleteContractorsFromTenderByUuid(this.tender.uuid, { participants: this.selectedUuids })
        this.loadData('tender-participants-table')
        this.updateTenderParticipants()
        this.selectedUuids = []
      },
      onShowGroupsChanged (value) {
        this.isShowGroups = value

        this.loadData('tender-participants-table')
      },
      async exportToExcel () {
        this.exportResult = await api.tendersExcels[`${this.tender.type}Participants`](this.tender.uuid)
      },
      onTableLoaded () {
        if (!this.isShowGroups) {
          return
        }

        setTimeout(() => {
          const rows = this.$refs['tender-participants-table'].$children

          // Reset highlight
          document.querySelectorAll('tr.is-highlight').forEach(r => r.classList.remove('is-highlight'))

          rows.forEach((row, i) => {
            const rowElement = row.$el

            if (rowElement.tagName !== 'TR') {
              return
            }

            rows.forEach((item, j) => {
              if (
                item.$el.tagName === 'TR' &&
                item.data.item.shortTitle === row.data.item.shortTitle &&
                i !== j
              ) {
                item.$el.classList.add('is-highlight')
              }
            })
          })
        }, 0)
      },
    }
  }
</script>

<style lang="scss" scoped>
  @import "~common-components/src/assets/style/ob-style";
  @import "~common-components/src/static/css/mixins";

  .contractors-groups {
    display: flex;
    flex-wrap: wrap;
  }

  .contractors-group {
    @include font-mixin(14px, 15px, 400, $color-text-base);

    display: flex;
    align-items: center;
    justify-content: space-between;
    padding: 8px 10px;
    border-radius: 25px;
    background: $lavender;
    margin-right: 13px;
    min-height: 30px;
    text-align: center;
    cursor: pointer;
    transition: .3s ease;
    will-change: opacity;
    text-decoration: none;

    &:hover {
      opacity: .8;
    }
  }

  .field-row {
    display: flex;
    justify-content: flex-start;
    margin-bottom: 10px;
    align-items: flex-start;

    &.mb2 {
      margin-top: 15px;
      margin-bottom: 30px;
    }

    > div {

      &:nth-child(1) {
        width: 180px;
        margin-right: 10px;
        flex: none;
        @include font-mixin(14px, 20px, 400, $color-grey-span);
      }
      &:nth-child(2) {
        width: 100%;
        @include font-mixin(14px, 20px, 400, $color-text-base); 
      }
    }
  } 

  .modal-link {
    @include font-mixin(14px, 18px, 400, $color-blue-navy-blue, 0.4px);

    margin-top: 20px;
  }

  .selected-rows-info {
    margin-right: 22px;
    color: $color-error;
    display: flex;
    align-items: center;

    .icon {
      font-size: 24px;
      margin-right: 8px;

      &::before {
        color: $color-error;
      }
    }
  }

  .participant-statistics {
    border: 1px solid $lavender;
    border-radius: 4px;
    overflow: hidden;
    margin-top: 15px;
  }

  .statistics-table {
    border-collapse: collapse;
    width: 100%;
    table-layout: fixed;

    tr {
      border-bottom: 1px solid $lavender;

      &:last-child {
        border-color: transparent
      }
    }

    th, td {
      @include font-mixin(14px, 18px, 400, $color-text-base);

      padding: 10px 20px;
      width: 90px;
      box-sizing: border-box;
      text-align: right;
      min-height: 45px;

      &:first-child {
        width: 100%;
        text-align: left;
      }

      &:nth-child(4) {
        background: rgba(214, 226, 246, .2);
      }
    }

    th {
      @include font-mixin(11px, 12px, 400, $shale-gray);

      text-transform: uppercase;
      padding: 14px 20px;
    }
  }

  .participant-table::v-deep {
    .is-highlight > td {
      background-color: rgba($gorse-yellow, .1) !important;

      &.--sticky.--sticky-column-last {
        background: linear-gradient(-90deg, rgba($gorse-yellow, .1) 0, $cssTableStyle_gradient_color_2 4px, rgba($gorse-yellow, .1) 4px, rgba($gorse-yellow, .1) 100%) !important;
      }
    }

    .row-checkbox.with-margin {
      margin-left: 20px;
    }
  }

</style>
